from math import sqrt
def hex2rgb(hexColor, maxVal = 255):
	if hexColor[0] == '#': hexColor = hexColor[1:]
	elif hexColor[0:2].lower() == '0x': hexColor = hexColor[2:]
	return color(float(int('0x'+hexColor[0:2], 16))/255, float(int('0x'+hexColor[2:4], 16))/255, float(int('0x'+hexColor[4:6], 16))/255)

def avg(ls): return sum(ls)/len(ls)
def method2(item, iterable):
	d = []
	for i in iterable:
		score = []
		if i == None: continue
		for j in i:
			score.append(
						abs(j-item[i.index(j)]))
			a = avg(score)
			d += [(a, i)]
		d.sort()
		return iterable.index(d[0][1])

def method1(item, iterable):
	d = []
	for i in iterable:
		if i == None: continue
		a = sqrt((item.r-i.r)**2 + (item.g-i.g)**2 + (item.b-i.b)**2)
		d += [(a, i)]
	d.sort()
	return iterable.index(d[0][1])

colors = [None]*512
for l in open('/Users/impiaaa/Library/LDRAW/ldconfig.ldr', 'U').readlines(): #'ldconfig-6163.ldr'
	if len(l) <= 2: continue
	elif l[2]=='!':
		colors[int(
				l[33:36])]=hex2rgb(l[45:51])

ci = ximport("coreimage")
img = "Finder.png"
w, h = imagesize(img)
sz = 0.3125*inch
size(w*sz, h*sz)
del w, h
canvas = ci.canvas(WIDTH, HEIGHT)
l = canvas.layer(img)
p = l.pixels()
s = ''
closest = method1
for y in range(int(HEIGHT/sz)):
	for x in range(int(WIDTH/sz)):
		c = closest(p.get_pixel(x, y), colors)
		s += '1 %s %s 0 %s 1 0 0 0 1 0 0 0 1 3005.dat\n' % (c, x*20, y*20)
		fill(colors[c])
		rect(x*sz, y*sz, sz, sz)
		stroke(0)
		oval((x*sz)+((sz-(0.1875*inch))/2), (y*sz)+((sz-(0.1875*inch))/2), 0.1875*inch, 0.1875*inch)
		nostroke()
	stroke(0)
	line(0, y*sz, WIDTH, y*sz)
	nostroke()

stroke(0)
for x in range(int(WIDTH/sz)): line(x*sz, 0, x*sz, HEIGHT)
open(img[:img.find('.')]+'.ldr', 'w').write(s)
